=begin

((<MatrixAlgebra>))
/
((<MatrixAlgebra::Vector>))
/
((<MatrixAlgebra::Covector>))
/
((<GaussianElimination>))

= MatrixAlgebra
((*(sNX)*))

s\܂Bۂ̃NX𐶐ɂ͊ƃTCYw肵āA
NX\bh ((<MatrixAlgebra.create>)) 邢͊֐ ((<MatrixAlgebra>))
p܂B

TuNXƂ ((<MatrixAlgebra::Vector>))(cxNgj, 
((<MatrixAlgebra::Covector>))(xNg), 
((<MatrixAlgebra::SquareMatrix>))(s) ܂B

== t@C:
* ((|matrix-algebra.rb|))

== X[p[NX:

* ((|Object|))

== CN[hĂ郂W[:

* ((<GaussianElimination>))

== ֘A֐:

--- MatrixAlgebra(ground, m, n)
    ((<MatrixAlgebra.create(ground, m, n)>))ƓłB

== NX\bh:

--- MatrixAlgebra.create(ground, m, n)
     ((|ground|)) vfƂ, (({ (m, n) })) ^̍s
    \NX𐶐܂B

    ̃\bh̖߂l ((<MatrixAlgebra>)) NX̃TuNX
    łB̃TuNXɂ̓NX\bhƂ ((|ground|)) 
    ((|rsize|)), ((|csize|)),  ((|sizes|)) `AꂼA
    ƂȂ ((|ring|))As̃TCY ((|m|)), ̃TCY ((|n|)),
    ̔z (({ [m, n] })) Ԃ܂B

    ۂɍsɂ ((<MatrixAlgebra.new>)),  ((<MatrixAlgebra.matrix>)), 
    ((<MatrixAlgebra.[]>)) g܂B

--- MatrixAlgebra.new(array)
    ((|array|)) z̔zƂƂAvfƂsԂ܂B

    :
      M = MatrixAlgebra(Integer, 2, 3)
      a = M.new([[1, 2, 3], [4, 5, 6]])
      a.display
        #=> [1, 2, 3]
        #=> [4, 5, 6]

--- MatrixAlgebra.matrix{|i, j| ... }
    ((|i|))  ((|j|)) ɍsƗ̃CfbNX^ ... ]l
    (({ (i, j) })) ɂsԂ܂B
    
    :
      M = MatrixAlgebra(Integer, 2, 3)
      a = M.matrix{|i, j| 10*(i + 1) + j + 1}
      a.display
        #=> [11, 12, 13]
        #=> [21, 22, 23]

--- MatrixAlgebra.[](array1, array2, ..., arrayr)
    z (({array1, array2, ..., arrayr})) ꂼsƂzԂ܂B

    :
      M = MatrixAlgebra(Integer, 2, 3)
      a = M[[1, 2, 3], [4, 5, 6]]
      a.display
        #=> [1, 2, 3]
        #=> [4, 5, 6]

--- MatrixAlgebra.collect_ij{|i, j| ... }
    ((<MatrixAlgebra.matrix>)) ɂ悭Ă܂A
    Ԃl MatrixAlgebra łȂA2dz(Array  Array)łB

--- MatrixAlgebra.collect_row{|i| ... }
     i s ... ]ēzׂsԂ܂B

    :
      M = MatrixAlgebra(Integer, 2, 3)
      A = M.collect_row{|i| [i*10 + 11, i*10 + 12, i*10 + 13]}
      A.display
        #=> [11, 12, 13]
        #=> [21, 22, 23]

--- MatrixAlgebra.collect_column{|j| ... }
     j  ... ]ēzׂsԂ܂B

    :
      M = MatrixAlgebra(Integer, 2, 3)
      A = M.collect_column{|j| [11 + j, 21 + j]}
      A.display
        #=> [11, 12, 13]
        #=> [21, 22, 23]

--- MatrixAlgebra.*(otype)
    2̍š^|VNXԂ܂B

    :
      M = MatrixAlgebra(Integer, 2, 3)
      N = MatrixAlgebra(Integer, 3, 4)
      L = M * N
      p L.sizes #=> [3, 4]

--- MatrixAlgebra.vector
    ((<rsize>)) ƓTCY̏cxNg(Vector)NXԂ܂B

--- MatrixAlgebra.covector
    ((<csize>)) ƓTCỶxNg(CoVector)NXԂ܂B

--- MatrixAlgebra.transpose
    ]usVsNXԂ܂B

--- MatrixAlgebra.zero
    sԂ܂B

#--- MatrixAlgebra.matrices; Matrices; end
#--- MatrixAlgebra.regulate(x)

== \bh:
#--- dup
--- [](i, j)
    (({(i, j)})) Ԃ܂B

--- []=(i, j, x)
    (({(i, j)}))  x ɂ܂B

--- rsize
    sTCYԂ܂B((<MatrixAlgebra.rsize>)) ƓłB

--- csize
    TCYԂ܂B((<MatrixAlgebra.csize>)) ƓłB

--- sizes
    [((<rsize>)), ((<csize>))] ̔zԂ܂B
    ((<MatrixAlgebra.sizes>)) ƓłB

--- rows
    esvfƂzԂ܂B
    
    :
      M = MatrixAlgebra(Integer, 2, 3)
      a = M.new([[1, 2, 3], [4, 5, 6]])
      p a.rows #=> [[1, 2, 3], [4, 5, 6]]
      p a.row(1) #=> [4, 5, 6]
      a.set_row(1, [40, 50, 60])
      a.display #=> [1, 2, 3]
                #=> [40, 50, 60]

--- row(i)
    i sڂzƂĕԂ܂B

--- set_row(i, array)
    i sڂz array ɓꊷ܂B

--- columns
    evfƂzԂ܂B
    
    :
      M = MatrixAlgebra(Integer, 2, 3)
      a = M.new([[1, 2, 3], [4, 5, 6]])
      p a.columns #=> [[1, 4], [2, 5], [3, 6]]
      p a.column(1) #=> [2, 5]
      a.set_column(1, [20, 50])
      a.display #=> [1, 20, 3]
                #=> [4, 50, 6]

--- column(j)
    j ڂzƂĕԂ܂B

--- set_column(j, array)
    j ڂz array ɓꊷ܂B

--- each{|row| ...}
    eszɂ ((|row|)) ɓCe[^łB

--- each_index{|i, j| ...}
    eY (({ (i, j) })) ɊւCe[^łB

--- each_i{|i| ...}
    es̓Y (({i})) ɊւCe[^łB

--- each_j{|j| ...}
    e̓Y (({j})) ɊւCe[^łB

--- each_row{|r| ... }
    eszɂ ((|r|)) ɓCe[^łB
    ((<each>)) ƓłB

--- each_column{|c| ... }
    ezɂ ((|c|)) ɓCe[^łB

--- matrix{|i, j| ... }
    ((<MatrixAlgebra.matrix>)) ƓłB

--- collect_ij{|i, j| ... }
    ((<MatrixAlgebra.collect_ij>)) ƓłB

--- collect_row{|i| ... }
    ((<MatrixAlgebra.collect_row>)) ƓłB

--- collect_column{|j| ... }
    ((<MatrixAlgebra.collect_column>)) ƓłB

--- ==(other)
    Ƃ^Ԃ܂B

--- +(other)
    avZ܂B

--- -(other)
    vZ܂B

--- *(other)
    ςvZ܂B
    
    :
      M = MatrixAlgebra(Integer, 2, 3)
      N = MatrixAlgebra(Integer, 3, 4)
      L = M * N
      a = M[[1, 2, 3], [4, 5, 6]]
      b = N[[-3, -2, -1, 0], [1, 2, 3, 4], [5, 6, 7, 8]]
      c = a * b
      p c.type  #=> L
      c.display #=> [14, 20, 26, 32]
                #=> [23, 38, 53, 68]

--- **(n)
    ((|n|)) vZ܂B

--- /(other)
    vZ܂B

--- transpose
    ]usԂ܂B

    :
      M = MatrixAlgebra(Integer, 2, 3)
      a = M.new([[1, 2, 3], [4, 5, 6]])
      Mt = M.transpose
      b = a.transpose
      p b.type  #=> Mt
      b.display #=> [1, 4]
                #=> [2, 5]
                #=> [3, 6]

#--- to_s

--- dup
    ܂B
    
    :
      M = MatrixAlgebra(Integer, 2, 3)
      a = M.new([[1, 2, 3], [4, 5, 6]])
      b = a.dup
      b[1, 1] = 50
      a.display #=> [1, 2, 3]
                #=> [4, 5, 6]
      b.display #=> [1, 2, 3]
                #=> [4, 50, 6]

--- display([out])
    s ((|out|)) ɕ\܂B((|out|)) ȗ ((|$stdout|))
    ɕ\܂B
    
#--- inspect

= MatrixAlgebra::Vector
((*(cxNgNX)*))

xNg̃NXłB

== X[p[NX:

* ((|MatrixAlgebra|))

== CN[hĂ郂W[:

Ȃ

== ֘A֐:

--- Vector(ground, n)
    ((<MatrixAlgebra::Vector.create(ground, n)>))ƓłB

== NX\bh:

--- MatrixAlgebra::Vector.create(ground, n)
     ((|ground|)) vfƂ, ((|n|)) ̃xNgicxNgj
    \NX𐶐܂B

    ̃\bh̖߂l ((<Vector>)) NX̃TuNX
    łB̃TuNXɂ̓NX\bhƂ ((|ground|)) 
    ((|size|)) `AꂼAƂȂ ((|ring|))A
    TCY ((|n|)) Ԃ܂B

    ۂɃxNgɂ ((<MatrixAlgebra::Vector.new>)),  
    ((<MatrixAlgebra::Vector.matrix>)), 
    ((<MatrixAlgebra::Vector.[]>)) g܂B
    
    ((<MatrixAlgebra::Vector>))  ((|n|)) s 1  
    ((<MatrixAlgebra>)) Ɠꎋ܂B

--- MatrixAlgebra::Vector.new(array)
    ((|array|)) zƂƂAvfƂ
    cxNgԂ܂B

    :
      V = Vector(Integer, 3)
      a = V.new([1, 2, 3])
      a.display
        #=> [1]
        #=> [2]
        #=> [3]

--- MatrixAlgebra::Vector.vector{|i| ... }
     ((|i|))  ... ɂxNgԂ܂B

    :
      V = Vector(Integer, 3)
      a = V.vector{|j| j + 1}
      a.display
        #=> [1]
        #=> [2]
        #=> [3]

--- MatrixAlgebra::Vector.matrix{|i, j| ... }
     ((|i|))  ... ɂxNgԂ܂B
    ((|j|)) ɂ͏ 0 ܂B

== \bh:

--- size
    Ԃ܂B

--- to_a
    ezɂĕԂ܂B

--- transpose
    xNg ((<MatrixAlgebra::Covector>)) ɓ]u܂B

= MatrixAlgebra::Covector
((*(xNgNX)*))

xNg̃NXłB

== X[p[NX:
* ((|MatrixAlgebra|))

== CN[hĂ郂W[:

Ȃ

== ֘A֐:

--- Covector(ground, n)
    ((<MatrixAlgebra::Covector.create(ground, n)>))ƓłB

== NX\bh:

--- MatrixAlgebra::Covector.create(ground, n)
     ((|ground|)) vfƂ, ((|n|)) ̃xNgixNgj
    \NX𐶐܂B

    ̃\bh̖߂l ((<Covector>)) NX̃TuNX
    łB̃TuNXɂ̓NX\bhƂ ((|ground|)) 
    ((|size|)) `AꂼAƂȂ ((|ring|))A
    TCY ((|n|)) Ԃ܂B

    ۂɃxNgɂ ((<MatrixAlgebra::Covector.new>)), 
    ((<MatrixAlgebra::Covector.matrix>)), 
    ((<MatrixAlgebra::Covector.[]>)) g܂B
    
    ((<MatrixAlgebra::Covector>))  1 s ((|n|))  ((<MatrixAlgebra>)) 
    ꎋ܂B

--- MatrixAlgebra::Covector.new(array)
    ((|array|)) zƂƂAvfƂ
    鉡xNgԂ܂B

    :
      V = Covector(Integer, 3)
      a = V.new([1, 2, 3])
      a.display
        #=> [1, 2, 3]

--- MatrixAlgebra::Covector.covector{|j| ... }
     j  ... ɂxNgԂ܂B

    :
      V = Covector(Integer, 3)
      a = V.covector{|j| j + 1}
      a.display
        #=> [1, 2, 3]

--- MatrixAlgebra::Covector.matrix{|i, j| ... }
     j  ... ɂxNgԂ܂Bi ɂ͏ 0 ܂B

== \bh:

--- size
    Ԃ܂B

--- to_a
    ezɂĕԂ܂B

--- transpose
    xNg ((<MatrixAlgebra::Vector>)) ɓ]u܂B

= MatrixAlgebra::SquareMatrix
((*(sNX)*))

s̍\NXłB

== X[p[NX:

* ((|MatrixAlgebra|))

== CN[hĂ郂W[:

Ȃ

== ֘A֐:

--- SquareMatrix(ground, size)
    ((<MatrixAlgebra::SquareMatrix.create(ground, n)>)) ƓłB

== NX\bh:

--- MatrixAlgebra::SquareMatrix.create(ground, n)

    s\NX𐶐܂B

    ̃\bh̖߂l SquareMatrix NX̃TuNX
    łB̃TuNXɂ̓NX\bhƂ ((|ground|)) 
    ((|size|)) `AꂼAƂȂ ((|ring|))A
    TCY ((|n|)) Ԃ܂B

    SquareMatrix  ((|n|)) s ((|n|))  MatrixAlgebra Ɠꎋ܂B

    ۂɍsɂ ((<MatrixAlgebra.new>)),  ((<MatrixAlgebra.matrix>)), 
    ((<MatrixAlgebra.[]>)) g܂B
    
--- MatrixAlgebra::SquareMatrix.unity
    PʍsԂ܂B

--- MatrixAlgebra::SquareMatrix.zero
    sԂ܂B

--- MatrixAlgebra::SquareMatrix.const(x)
     ((|x|)) ̃XJ[sԂ܂B

#--- self.regulate(x)

== \bh
--- size
    TCYԂ܂B

--- const(x)
     ((|x|)) ̃XJ[sԂ܂B
#--- self.matrices
--- determinant
    s񎮂Ԃ܂B

#--- sign(a)
#--- perm

--- char_polynomial(ring)
    ((|ring|)) ɑ^ƁAԂ܂B

= GaussianElimination
((*(KEX̏@W[)*))

KEX̑|o@郂W[łB

== t@C:
((|gaussian-elimination.rb|))

== CN[hĂ郂W[:

Ȃ

== NX\bh:

Ȃ

== \bh

--- swap_r!(i, j)
    ((|i|)) s ((|j|)) sꊷ܂B

--- swap_r(i, j)
    ((|i|)) s ((|j|)) sꊷ̂Ԃ܂B

--- swap_c!(i, j)
    ((|i|))  ((|j|)) ꊷ܂B

--- swap_c(i, j)
    ((|i|))  ((|j|)) ꊷ̂Ԃ܂B

--- multiply_r!(i, c)
    ((|i|)) sڂ ((|c|)) {܂B

--- multiply_r(i, c)
    ((|i|)) sڂ ((|c|)) {̂Ԃ܂B

--- multiply_c!(j, c)
    ((|j|)) ڂ ((|c|)) {܂B

--- multiply_c(j, c)
    ((|j|)) ڂ ((|c|)) {̂Ԃ܂B

--- mix_r!(i, j, c)
    ((|i|)) sڂ ((|j|)) sڂ ((|c|)) {𑫂܂B

--- mix_r(i, j, c)
    ((|i|)) sڂ ((|j|)) sڂ ((|c|)) {𑫂̂Ԃ܂B

--- mix_c!(i, j, c)
    ((|i|)) ڂ ((|j|)) ڂ ((|c|)) {𑫂܂B

--- mix_c(i, j, c)
    ((|i|)) ڂ ((|j|)) ڂ ((|c|)) {𑫂̂Ԃ܂B

--- left_eliminate!
    ̊{ό`ŊKisɕό`܂B
    
    ߂ĺAό`̂Ɏgs̐ςƁA̐s
    s񎮂łB
    
    :
      require "matrix-algebra"
      require "mathn"
      class Rational < Numeric
        def inspect; to_s; end
      end
      M = MatrixAlgebra(Rational, 4, 3)
      a = M.matrix{|i, j| i*10 + j}
      b = a.dup
      c, d = b.left_eliminate!
      b.display #=> [1, 0, -1]
                #=> [0, 1, 2]
                #=> [0, 0, 0]
                #=> [0, 0, 0]
      c.display #=> [-11/10, 1/10, 0, 0]
                #=> [1, 0, 0, 0]
                #=> [1, -2, 1, 0]
                #=> [2, -3, 0, 1]
      p c*a == b#=> true
      p d       #=> 1/10

--- left_inverse
    ̊{ό`ɂʋtsłB

--- left_sweep
    ̊{ό`ŊKisɂĕԂ܂B

--- step_matrix?
    KisłƂA(pivot)Ԃ܂BłȂƂAnil
    Ԃ܂B

--- kernel_basis
    E|ėɂȂxNg̋Ԃ̊̔zԂ܂B
    e ((<MatrixAlgebra::Vector>)) ̗vfłB

    :
      require "matrix-algebra"
      require "mathn"
      M = MatrixAlgebra(Rational, 5, 4)
      a = M.matrix{|i, j| i + j}
      a.display #=>
        #[0, 1, 2, 3]
        #[1, 2, 3, 4]
        #[2, 3, 4, 5]
        #[3, 4, 5, 6]
        #[4, 5, 6, 7]
      a.kernel_basis.each do |v|
        puts "a * #{v} = #{a * v}"
          #=> a * [1, -2, 1, 0] = [0, 0, 0, 0, 0]
          #=> a * [2, -3, 0, 1] = [0, 0, 0, 0, 0]
      end

--- determinant_by_elimination
    ̏̐s̍s񎮂|o@ŋ߂܂B
    
=end

